//
//  Base.swift
//  GoldWars
//
//  Created by Marcel Schwarz on 18.04.20.
//  Copyright © 2020 SP2. All rights reserved.
//

import SpriteKit
import GameplayKit
import GameKit

class Base: GKEntity {
    
    var unitCount: Int
    var adjacencyList: Array<Base>
    var changeOwnerShip: Bool
    var ownerShipPlayer: GKPlayer?
    
    init(position: CGPoint, player: GKPlayer? = nil, team: Team? = nil) {
        self.unitCount = 0
        self.adjacencyList = [Base]()
        self.changeOwnerShip = false
        self.ownerShipPlayer = player
        super.init()
        
        addComponent(DefaultBaseComponent(texture: SKTexture(imageNamed: "Base"), position: position))
        if(team != nil){
            addComponent(TeamComponent(team: team!, position: position))
            self.unitCount = 500
        }
    }
    
    func attackBase(base: Base, units:Int) -> [GKEntity]{
        base.changeOwnerShip = true
        base.ownerShipPlayer = self.ownerShipPlayer
        self.unitCount -= units
        base.unitCount += units
        return [self, base]
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
